#include<stdio.h>
#include <unistd.h>
#include<string.h>
#include"serial_head.h"
#include "udp_head.h"
#include <time.h>
#include <unistd.h>

long long int  get_time_display()
{
	time_t t;//不能直接声明为指针变量，不然就会产生野指针
	int microseconds=0;
	long long int second_my = 0;
	long long int second_msecond = 0;
	struct tm *ptm;
	struct timeval microseconds_struct;
	gettimeofday(&microseconds_struct, NULL);
	microseconds = (long int)microseconds_struct.tv_usec;

	time(&t);        //2.获取系统从1970 00：00：00以来的秒数
	second_my = (long long int)t;
    
	second_msecond = second_my*1000+microseconds;

	return second_msecond;
}

long long int getCurrentTime()    
{    
	struct timeval tv;   
	unsigned long long sec = 0; 
	unsigned long long usec = 0; 		
	gettimeofday(&tv,NULL); 
	sec = (unsigned long long )tv.tv_sec;
	usec = (unsigned long long )tv.tv_usec;
	return sec * 1000 + usec / 1000;     
} 

int main(int argc, const char *argv[])
{
	
	int fd;
	int nwrite,i;
	char message_t[64] = {0};
	char message_r[64] = {0};
	unsigned char recv_mes_num = 0;
	unsigned int recv_times=0;
	char *delim = ",";
	char *message_p[6]={NULL};
	long long int message_data[6];
	long long int msecond = 0;
	
	//serial
	if((fd=open_port(0))<0)
	{
		perror("open_port error");
		return -1;
	}
	if((i=set_opt(fd,115200,8,'N',1))<0)
	{
		perror("set_opt error");
		return -1;
	}
	printf("fd=%d\n",fd);

	


	//udp
	int sockpid;
	//struct mes message;
	struct sockaddr_in serverstruct,clienstruct;
	socklen_t clienstruct_len=sizeof(clienstruct);
	if ( -1 == (sockpid = socket(AF_INET,SOCK_DGRAM,0))){
		err_exit("socket");
	}
	serverstruct.sin_family = AF_INET;
	serverstruct.sin_port = htons(SER_PORT);
	serverstruct.sin_addr.s_addr = inet_addr(SER_IP);
	
	if ( -1 == bind(sockpid,(struct sockaddr *)&serverstruct,sizeof(serverstruct))){
		err_exit("bind");
	}
	
	while(1){
	
		if ( -1 == (recv_mes_num=recvfrom(sockpid,message_r,sizeof(message_r)*2,0,
					(struct sockaddr *)&clienstruct,&clienstruct_len))){
			err_exit("recvfrom");
		}
		
		printf("receive client message......\n");
		printf("receive message number:%d\n",recv_mes_num);
	
		msecond = getCurrentTime();			
		if(message_r[0]=='#')
		{
			switch(message_r[1]){
			case'0':
		
				nwrite = write(fd,message_r,sizeof(message_r));
				printf("send to STC51 message......\n");
				printf("%s\n",message_r);

				message_p[0]=strtok(message_r,delim);
				message_p[0]=strtok(NULL,delim);
				message_p[1]=strtok(NULL,delim);
				message_p[2]=strtok(NULL,delim);
				message_p[3]=strtok(NULL,delim);
				message_p[4]=strtok(NULL,delim);
				message_p[5]=strtok(NULL,delim);
				
				sscanf(message_p[5], "%lld", &message_data[5]);	
				printf("message_data[5]:%llu\n",message_data[5]);
				printf("my_get_mseconds:%llu\n",msecond);
				printf("recv-myself    :%llu\n",message_data[5]-msecond);
				
				break;
			case '2':
				break;
			case '3':
				break;
			case '4':
				break;
			default:
				break;
			
			}
		}
		else
		{
			printf("..................receive message err.............\n");
		}
		
	
	}
	close(sockpid);
	return 0;
}



